@echo off
set RETURNCODE=0
set SYS_DIR=system32
set LOGFILE=nul

rem ------ Check 32bit or 64bit ------
IF "%PROCESSOR_ARCHITECTURE%"=="AMD64" (set SYS_DIR=SysWOW64) ELSE (set SYS_DIR=system32)


echo Restore Start


rem ------ Check bak Files ------
set EXISTBAK=FALSE
IF EXIST %SystemRoot%\%SYS_DIR%\esmsmsrv.bak  set EXISTBAK=TRUE
IF EXIST %SystemRoot%\%SYS_DIR%\esmsmdmi.bak  set EXISTBAK=TRUE
IF EXIST %SystemRoot%\%SYS_DIR%\esmsmphp.bak  set EXISTBAK=TRUE
IF EXIST %SystemRoot%\%SYS_DIR%\esmsmsdr.bak  set EXISTBAK=TRUE
IF EXIST %SystemRoot%\%SYS_DIR%\esmsmsel.bak  set EXISTBAK=TRUE
IF EXIST %SystemRoot%\%SYS_DIR%\esmsmsen.bak  set EXISTBAK=TRUE
IF EXIST %SystemRoot%\%SYS_DIR%\esmcmmsg.bak  set EXISTBAK=TRUE

IF "%EXISTBAK%"=="FALSE" (
    set RETURNCODE=1
    echo No bak files exist.
    echo No bak files exist. >> %LOGFILE%
    goto end
)


rem ------ Service Stop ------
echo Stopping services...
net stop /y "ESMSystemManagementService" > NUL 2>&1
net stop /y "ESMCommonService" > NUL 2>&1
net stop /y "ESRAS_Utl" > NUL 2>&1
net stop /y "SNMP" > NUL 2>&1
net stop /y "AlertManagerMainService" > NUL 2>&1
net stop /y "ExpressPCReport" > NUL 2>&1
net stop /y "PowerSwService" > NUL 2>&1
net stop /y "PxeSvc" > NUL 2>&1
net stop /y "PxeMtftp" > NUL 2>&1
net stop /y "cliwatch" > NUL 2>&1
net stop /y "snrwatch" > NUL 2>&1
net stop /y "schwatch" > NUL 2>&1
net stop /y "bkressvc" > NUL 2>&1
net stop /y "rupdssvc" > NUL 2>&1
net stop /y "depssvc" > NUL 2>&1
net stop /y "clistart" > NUL 2>&1
net stop /y "ftsvc" > NUL 2>&1
net stop /y "esmpro_arc" > NUL 2>&1
net stop /y "winmgmt" > NUL 2>&1


rem ------ Copy Files ------
echo Rename files...

IF EXIST %SystemRoot%\%SYS_DIR%\esmsmsrv.bak (
    del /f %SystemRoot%\%SYS_DIR%\esmsmsrv.exe
    rename %SystemRoot%\%SYS_DIR%\esmsmsrv.bak esmsmsrv.exe
    IF NOT %errorlevel% == 0  set RETURNCODE=2
)

IF EXIST %SystemRoot%\%SYS_DIR%\esmsmdmi.bak (
    del /f %SystemRoot%\%SYS_DIR%\esmsmdmi.dll
    rename %SystemRoot%\%SYS_DIR%\esmsmdmi.bak esmsmdmi.dll
    IF NOT %errorlevel% == 0  set RETURNCODE=2
)

IF EXIST %SystemRoot%\%SYS_DIR%\esmsmphp.bak (
    del /f %SystemRoot%\%SYS_DIR%\esmsmphp.dll
    rename %SystemRoot%\%SYS_DIR%\esmsmphp.bak esmsmphp.dll
    IF NOT %errorlevel% == 0  set RETURNCODE=2
)

IF EXIST %SystemRoot%\%SYS_DIR%\esmsmsdr.bak (
    del /f %SystemRoot%\%SYS_DIR%\esmsmsdr.dll
    rename %SystemRoot%\%SYS_DIR%\esmsmsdr.bak esmsmsdr.dll
    IF NOT %errorlevel% == 0  set RETURNCODE=2
)

IF EXIST %SystemRoot%\%SYS_DIR%\esmsmsel.bak (
    del /f %SystemRoot%\%SYS_DIR%\esmsmsel.dll
    rename %SystemRoot%\%SYS_DIR%\esmsmsel.bak esmsmsel.dll
    IF NOT %errorlevel% == 0  set RETURNCODE=2
)

IF EXIST %SystemRoot%\%SYS_DIR%\esmsmsen.bak (
    del /f %SystemRoot%\%SYS_DIR%\esmsmsen.dll
    rename %SystemRoot%\%SYS_DIR%\esmsmsen.bak esmsmsen.dll
    IF NOT %errorlevel% == 0  set RETURNCODE=2
)

IF EXIST %SystemRoot%\%SYS_DIR%\esmcmmsg.bak (
    del /f %SystemRoot%\%SYS_DIR%\esmcmmsg.dll
    rename %SystemRoot%\%SYS_DIR%\esmcmmsg.bak esmcmmsg.dll
    IF NOT %errorlevel% == 0  set RETURNCODE=2
)


:srv_start
rem ------ Service Start ------
echo Starting services...
net start /y "winmgmt" > NUL 2>&1
net start /y "ExpressPCReport" > NUL 2>&1
net start /y "AlertManagerMainService" > NUL 2>&1
net start /y "ESMSystemManagementService" > NUL 2>&1
net start /y "ESMCommonService" > NUL 2>&1
net start /y "ESRAS_Utl" > NUL 2>&1
net start /y "PowerSwService" > NUL 2>&1
net start /y "PxeSvc" > NUL 2>&1
net start /y "PxeMtftp" > NUL 2>&1
net start /y "cliwatch" > NUL 2>&1
net start /y "snrwatch" > NUL 2>&1
net start /y "schwatch" > NUL 2>&1
net start /y "bkressvc" > NUL 2>&1
net start /y "rupdssvc" > NUL 2>&1
net start /y "depssvc" > NUL 2>&1
net start /y "clistart" > NUL 2>&1
net start /y "ftsvc" > NUL 2>&1
net start /y "esmpro_arc" > NUL 2>&1
net start /y "SNMP" > NUL 2>&1


:end
rem ------ Finish ------
IF %RETURNCODE%==0 (
    echo Restore End
) ELSE (
    echo error code : %RETURNCODE%
)
exit /b %RETURNCODE%

